// v1.3
// unidade que trata dos grupos de luzes de seo de corredor
unit LuzesCorredor ;


interface

uses Classes        ,
     Constantes    ;

type
   TLuzCorredor = class
   private
      _estado : Boolean ;  // estado significa grupo de luz aceso ou apagado
   public
      constructor Create                                          ;
      destructor  Destroy                              ; override ;
      function    obterEstado                          : Boolean  ;
      procedure   definirEstado( novoEstado : Boolean )           ;
   end ;


implementation

// todos os grupos de luzes de seo de corredor so criadas apagados
constructor TLuzCorredor.Create ;
begin
   _estado := false ;  // estado falso significa grupo de luz apagado
   inherited Create( ) ;
end ; // LuzCorredor.Create


// mtodo destrutor para a classe LuzCorredor
destructor TLuzCorredor.Destroy ;
begin
   // no faz nada!
   inherited Destroy( ) ;
end ; // LuzCorredor.Destroy


// devolve o estado do grupo de luzes de seo de corredor: aceso ou apagado
function TLuzCorredor.obterEstado : Boolean ;
begin
   result := _estado ;
end ; // LuzCorredor.obterEstado


// define um novo estado ao grupo de luzes da seo de corredor, que pode ser
// aceso (true) ou apagado (false)
procedure TLuzCorredor.definirEstado( novoEstado : Boolean ) ;
begin
   _estado := novoEstado ;
end ; // LuzCorredor.obterEstado

end.

// LuzCorredor.pas -> v1.3

