// v1.4
// unidade que trata das portas
unit Porta ;

interface

uses Constantes;

type
   TPorta = class
   private
      _estado : Boolean ;  // indica se porta est aberta ou fechada
   public
      constructor Create                     ;
      destructor  Destroy         ; override ;
      function    obterEstado     : Boolean  ;
      procedure   mudarEstadoPorta           ;
   end ; // TPorta


implementation

// Todas as portas so criadas fechadas
constructor TPorta.Create ;
begin
   _estado := false ;  // estado falso indica porta fechada
   inherited Create( ) ;
end ; // TPorta.Create


// funo destrutora para a classe porta
destructor TPorta.Destroy ;
begin
   // no faz nada!
    inherited Destroy( ) ;
end ; // TPorta.Destroy


// devolve estado da porta: aberto ou fechado
function TPorta.obterEstado : Boolean ;
begin
   result := _estado ;
end ; // TPorta.obterEstado


// abre uma porta fechada e fecha uma porta aberta
procedure TPorta.mudarEstadoPorta ;
begin
   _estado := NOT _estado ; // basta inverter o estado
end ; // TPorta.mudarEstadoPorta

end .

// Portas.pas -> v1.4
