unit Sensor;

interface

uses Classes       ,
     Constantes    ;

Type
   TSensor = class
     protected
        _estado : Integer ; // valor emitido pelo sensor
        _falha  : Boolean ; // indicador de falha no sensor
     public
        constructor Create                            ;
        function    obterEstado                       : Integer ; virtual ;
        procedure   definirEstado( estado : Integer ) ; virtual ;
        function    obterFalha                        : Boolean ; virtual ;
     end ; // TSensor

implementation

// cria e inicializa sensor
constructor TSensor.Create ;
begin
   _estado := 0 ;      // inicialmente no detecta ocupao
   _falha := false ;   // inicialmente ele est funcionando
end ; // TSensor.Create

// devolve o estado de um sensor, que pode ser de movimento como de luz
function TSensor.obterEstado : Integer ;
begin
     result := _estado ;
end ; // Sensor.obterEstado


// permite definir um novo estado para o sensor
procedure TSensor.definirEstado( estado : Integer ) ;
begin
     if ( _falha = false ) // s muda estado se sensore estiver funcionando
     then
     begin

        if ( estado < 0 ) // o estado de um sensor no deve ser negativo
        then
        begin
           estado := 0 ;  // se for, ele  colocado como sendo zero
        end ; // if

        _estado := estado ;  // estado do sensor recebe o novo estado

     end ; // if
end ; // Sensor.definirEstado


// devolve indicao de falha
// true = falhado e false = funcionando corretamente
function TSensor.ObterFalha : Boolean ;
begin
   Result := _falha ;
end ; // Sensor.ObterFalha

end.
