unit Unt_Sala;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ImgList, StdCtrls, Buttons, ComCtrls, LED,
//Importadas do projeto
  Constantes, salas;

type
  Tfrm_FM_Sala = class(TForm)
    GroupBox1: TGroupBox;
    TB_T3: TTrackBar;
    Label1: TLabel;
    GroupBox2: TGroupBox;
    BB_Luzes: TBitBtn;
    IL_Led: TImageList;
    Btn_Sair: TButton;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    LED1: TLED;
    procedure FormShow(Sender: TObject);
    procedure BB_LuzesClick(Sender: TObject);
    procedure Btn_SairClick(Sender: TObject);
    procedure Label6Click(Sender: TObject);
    procedure Label7Click(Sender: TObject);
    procedure Label8Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure TB_T3Change(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    FM_Sala_ID : String;

    SimSala    : TSala;
  end;

var
  frm_FM_Sala: Tfrm_FM_Sala;

implementation
uses unt_main;

{$R *.DFM}

procedure Tfrm_FM_Sala.FormShow(Sender: TObject);
begin
   self.Caption :=  'Facility Manager - Mapa da Sala - ID ' + FM_Sala_ID;
   IL_Led.GetBitmap(1,BB_Luzes.Glyph);

   SimSala:= frm_main.Sim_Andar.obterSala (FM_Sala_ID);

   //Obtend o estado das portas
   if SimSala.obterPorta(0).ObterEstado then
      Label7.Caption:= 'Porta Aberta'
   else
       Label7.Caption:= 'Porta Fechada';

   if SimSala.obterPorta(1).ObterEstado then
      Label8.Caption:= 'Porta Aberta'
   else
       Label8.Caption:= 'Porta Fechada';

       //Obtendo o status do sensor de movimento
       if SimSala.obterSensorMov.obterEstado <> 0 then
          begin
          Label6.Caption:= 'No h movimento';
          LED1.Color:= lcRed;
          end
       else
           begin
           Label6.Caption:= 'H movimento';
           LED1.Color:= lcGreen;
           end;//else

       //Obtendo T3
       TB_T3.Position:= SimSala.ObterT3;

       //Obtendo status da Luz
       if (SimSala.obterLuz(0).ObterEstado > 10) then
          BB_Luzes.Caption:= 'Acender'
       else
           BB_Luzes.Caption:= 'Apagar';
end;

procedure Tfrm_FM_Sala.BB_LuzesClick(Sender: TObject);
begin
   if BB_Luzes.Caption = 'Apagar'
       then
           Begin
           BB_Luzes.Glyph := NIL;
           IL_Led.GetBitmap(0,BB_Luzes.Glyph);
           BB_Luzes.Caption := 'Acender';

           //Comando o apagamento das luzes
           SimSala.apagarLuz;
           end
       else
           Begin
           BB_Luzes.Glyph := NIL;
           IL_Led.GetBitmap(1,BB_Luzes.Glyph);
           BB_Luzes.Caption := 'Apagar';

           //Comando o acendimento das luzes
           SimSala.acenderLuz;
           end;
end;

procedure Tfrm_FM_Sala.Btn_SairClick(Sender: TObject);
begin
   Frm_FM_Sala.Close;
end;

procedure Tfrm_FM_Sala.Label6Click(Sender: TObject);
begin
  If Label6.Caption = 'H Movimento.'
     then Label6.Caption := 'No h Movimento.'
     else Label6.Caption := 'H Movimento.'
end;

procedure Tfrm_FM_Sala.Label7Click(Sender: TObject);
begin
  SimSala.ObterPorta(0).MudarEstadoPorta;

  if Label7.Caption = 'Porta fechada'
     then Label7.Caption := 'Porta Aberta'
     else Label7.Caption := 'Porta fechada';
end;

procedure Tfrm_FM_Sala.Label8Click(Sender: TObject);
begin
  SimSala.ObterPorta(1).MudarEstadoPorta;

  if Label8.Caption = 'Porta fechada'
     then Label8.Caption := 'Porta Aberta'
     else Label8.Caption := 'Porta fechada';
end;

procedure Tfrm_FM_Sala.FormCreate(Sender: TObject);
begin
     SimSala:= TSala.Create( '', NIL, 0 );
end;

procedure Tfrm_FM_Sala.TB_T3Change(Sender: TObject);
begin
     SimSala.definirT3 (TB_T3.Position);
end;

end.
